> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/faq/separate-opacity-for-fill-and-stroke.md).

# Separate opacity for fill and stroke

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

When creating an **Annotation** with WebViewer, you may want to set different opacity values for the fill and stroke. For example having the fill semi-transparent and the stroke completely opaque.

Unfortunately the PDF specification doesn't allow for separate alpha values for the stroke and fill color. Instead it provides an opacity value that applies to the entire annotation. With that said, it is possible to customize this so that the stroke and fill colors have different opacity values when the annotation is viewed in WebViewer. (**Note**: this solution won't work in any other PDF viewers if we download the file).

To achieve this, we could do it is using the [`setCustomData`](https://sdk.apryse.com/api/web/Core.Annotations.Annotation.html#setCustomData) API on the annotation. For example:

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
myAnnot.setCustomData('fillOpacity', '0.5');
myAnnot.FillColor.A = 0.5;
```

{% endcode %}
{% endtab %}
{% endtabs %}

Then when we reload the PDF we can listen to `annotationChanged` and update the opacity based on the fill opacity custom data. For example:

{% tabs %}
{% tab title="JavaScript (SDK v8.0+)" %}
{% code lineNumbers="true" %}

```js
annotManager.addEventListener('annotationChanged', (annotations, action) => {
  if (action === 'add') {
    annotations.forEach(annotation => {
      const fillOpacity = annotation.getCustomData('fillOpacity');
      if (fillOpacity) {
        annotation.FillColor.A = parseInt(fillOpacity, 10);
      }
    });
  }
});
```

{% endcode %}
{% endtab %}

{% tab title="JavaScript (SDK v6.0+)" %}
{% code lineNumbers="true" %}

```js
annotManager.on('annotationChanged', (annotations, action) => {
  if (action === 'add') {
    annotations.forEach(annotation => {
      const fillOpacity = annotation.getCustomData('fillOpacity');
      if (fillOpacity) {
        annotation.FillColor.A = parseInt(fillOpacity, 10);
      }
    });
  }
});
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/get-started/faq/separate-opacity-for-fill-and-stroke.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
